!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

    include('System_XML_IncludeInAllClassHeaderFiles.inc'),once
    !include('System_XML_System_ErrorManager.inc'),once
    include('System_XML_CenterPointInterfaces.inc'),once
    include('System_XML_Element.inc'),once
    Include('System_XML_Comment.inc'),Once
    Include('System_XML_Text.inc'),Once
    Include('System_XML_XPath.inc'),Once
    Include('System_XML_CharacterData.inc'),Once
    Include('System_XML_CDataSection.inc'),Once
    Include('System_XML_XPathQuery.inc'),Once


System_XML_Document                         Class(System_XML_Node),Type,Module('System_XML_Document.CLW'),Link('System_XML_Document.CLW',_System_XML_Classes_LinkMode_),Dll(_System_XML_Classes_DllMode_)
DocumentElement                                 &System_XML_Element
Query                                           &System_XML_XPathQuery
XPath                                           &System_XML_XPath
Construct                                       Procedure()
Destruct                                        Procedure()
AddElementToDom                                 procedure(System_XML_CenterPoint_Document DOMDocument,System_XML_Node modeledNode,System_XML_CenterPoint_Element parentDOMElement)
!CreateAttribute                                 PROCEDURE(const *CSTRING name),*System_XML_Attribute
!CreateAttributeNS                               PROCEDURE(const *CSTRING namespaceURI,const *CSTRING qualifiedName),*System_XML_Attribute
CreateCDATASection                              PROCEDURE(STRING data),*System_XML_CDATASection
CreateChildNode                                 procedure(string parentName,string nodeName),*System_XML_Node,virtual
CreateComment                                   PROCEDURE(STRING comment),*System_XML_Comment
!CreateDocumentFragment                          PROCEDURE(),*System_XML_DocumentFragment
CreateElement                                   PROCEDURE(STRING tagName),*System_XML_Element
!CreateElementNS                                 PROCEDURE(const *CSTRING namespaceURI,const *CSTRING qualifiedName),*System_XML_Element
!CreateEntityReference                           PROCEDURE(const *CSTRING name),*System_XML_EntityReference
CreateNode                                      PROCEDURE(STRING tagName),*System_XML_Node
CreateObjectGraph                               procedure(System_XML_CenterPoint_Document document)
!CreateProcessingInstruction                     PROCEDURE(const *CSTRING target,const *CSTRING data),*System_XML_ProcessingInstruction
CreateTextNode                                  PROCEDURE(STRING data),*System_XML_Text
DisposeXPath                                    procedure,virtual
FromFile                                        procedure(string filename,bool BuildObjectGraph=true),long
FromString                                      procedure(string xml),long
GetDocumentElement                              PROCEDURE(),*System_XML_Element
GetNodeText                                     procedure(System_XML_CenterPoint_Node domNode),string
!GetElementById                                  PROCEDURE(const *CSTRING elementId),*System_XML_Element
!GetElementsByTagName                            PROCEDURE(const *CSTRING name),*System_XML_NodeList
!GetElementsByTagNameNS                          PROCEDURE(const *CSTRING namespaceURI,const *CSTRING localName),*System_XML_NodeList
GetFirstNode                                    procedure(string nodeName),*System_XML_Node
!ImportNode                                      PROCEDURE(*System_XML_Node importedNode,byte deep),*System_XML_Node
InstantiateXPath                                procedure,virtual
OnObjectGraphCreated                            procedure,virtual
SetDocumentElementName                          procedure(string name)
ToString                                        procedure,string
WalkDomTreeAndCreateObjects                     procedure(System_XML_Node node_,System_XML_CenterPoint_Node domNode)

                                            End


