!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

    include('System_XML_IncludeInAllClassHeaderFiles.inc'),once
    Include('System_XML_Node.inc'),Once


System_XML_Element                          Class(System_XML_Node),Type,Module('System_XML_Element.CLW'),Link('System_XML_Element.CLW',_System_XML_Classes_LinkMode_),Dll(_System_XML_Classes_DllMode_)
!Text                                            &Cstring
Construct                                       Procedure()
Destruct                                        Procedure()
!GetAttribute                                    procedure( const *cstring name), *cstring
!GetAttributeNode                                procedure( const *cstring name), *System_XML_Attr
!GetElementsByTagName                            procedure( const *cstring name), *System_XML_NodeList
!GetTagName                                      procedure(), *cstring
!RemoveAttribute                                 procedure( const *cstring name), byte
!RemoveAttributeNode                             procedure( *System_XML_Attr oldAttr), *System_XML_Attr
SetAttribute                                    procedure(string name,string value), byte,proc
!SetAttributeNode                                procedure( *System_XML_Attr newAttr), *System_XML_Attr
!! DOM Level 2
!GetAttributeNodeNS                              procedure( const *cstring namespaceURI, const *cstring localName), *System_XML_Attr
!GetAttributeNS                                  procedure( const *cstring namespaceURI, const *cstring localName), *cstring
!HasAttribute                                    procedure( const *cstring name), byte
!HasAttributeNS                                  procedure( const *cstring namespaceURI, const *cstring localName), byte
!RemoveAttributeNS                               procedure( const *cstring namespaceURI, const *cstring localName), byte
!SetAttributeNodeNS                              procedure( *System_XML_Attr newAttr), *System_XML_Attr
!SetAttributeNS                                  procedure( const *cstring namespaceURI, const *cstring qualifiedName, const *cstring value), byte
                                            End


