!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

    include('System_XML_IncludeInAllClassHeaderFiles.inc'),once
    !include('System_XML_System_ErrorManager.inc'),once
    Include('System_XML_NodeList.inc'),Once
    Include('System_XML_AttrList.inc'),Once

                                                    itemize(1),pre(System_XML_NodeType)
ELEMENT                                                 EQUATE
ATTRIBUTE                                               EQUATE
TEXT                                                    EQUATE
CDATA_SECTION                                           EQUATE
ENTITY_REFERENCE                                        EQUATE
ENTITY                                                  EQUATE
PROCESSING_INSTRUCTION                                  EQUATE
COMMENT                                                 EQUATE
DOCUMENT                                                EQUATE
DOCUMENT_TYPE                                           EQUATE
DOCUMENT_FRAGMENT                                       EQUATE
NOTATION                                                EQUATE
                                                    end


System_XML_Node                                     Class,Type,Module('System_XML_Node.CLW'),Link('System_XML_Node.CLW',_System_XML_Classes_LinkMode_),Dll(_System_XML_Classes_DllMode_)
Attributes                                              &System_XML_AttrList
ChildNodes                                              &System_XML_NodeList
IsRootElement                                           bool
NodeName                                                cstring(256)
NodePath                                                cstring(2000)
NodeType                                                long
NodeValue                                               &cstring
!Node                                            Cstring(100)
Construct                                               Procedure()
Destruct                                                Procedure()
AddAttribute                                            procedure(string name,string value)
AddChildNode                                            procedure(*System_XML_Node childNode)
AddChildNode                                            procedure(string nodeName,long nodeType=System_XML_NodeType:Element),*System_XML_Node
AppendChildNode                                         PROCEDURE(*System_XML_Node newChild),*System_XML_Node,proc
CloneFrom                                               procedure(System_XML_Node sourceNode)
!CloneNode                                           PROCEDURE(*System_XML_Node,byte deep),*System_XML_Node
DisposeNodeValue                                        procedure,protected
GetAttribute                                            procedure(string name),string
!GetAttributes                                       PROCEDURE,*System_XML_NamedNodeMap
!GetChildNodes                                       PROCEDURE,*System_XML_NodeList
GetFirstNode                                            procedure(string nodeName),*System_XML_Node
!GetFirstChild                                       PROCEDURE,*System_XML_Node
!GetLastChild                                        PROCEDURE,*System_XML_Node
!GetNextSibling                                      PROCEDURE,*System_XML_Node
!GetNodeName                                         PROCEDURE,*CSTRING
!GetNodeType                                         PROCEDURE,UNSIGNED
GetNodeName                                             procedure,string
GetNodeValue                                            procedure,string
!GetOwnerDocument                                    PROCEDURE,*System_XML_Document
!GetParentNode                                       PROCEDURE,*System_XML_Node
!GetPreviousSibling                                  PROCEDURE,*System_XML_Node
!HasChildNodes                                       PROCEDURE,byte
InsertBefore                                            PROCEDURE(*System_XML_Node newChild,*System_XML_Node refChild),*System_XML_Node,proc
!RemoveChild                                         PROCEDURE(*System_XML_Node,*System_XML_Node oldChild),*System_XML_Node,proc
!ReplaceChild                                        PROCEDURE(*System_XML_Node,*System_XML_Node newChild,*System_XML_Node oldChild),*System_XML_Node
Reset                                                   procedure
SetAttribute                                            procedure(string attributeName,string attributeValue)
SetNodeName                                             procedure(string name)
SetNodeValue                                            procedure(string value)
!! DOM Level 2
!Normalize                                           PROCEDURE
!GetLocalName                                        PROCEDURE,*CSTRING
!GetNamespaceURI                                     PROCEDURE,*CSTRING
!GetPrefix                                           PROCEDURE,*CSTRING
!HasAttributes                                       PROCEDURE,byte
!IsSupported                                         PROCEDURE(*System_XML_Node,const *CSTRING feature,const *CSTRING version),byte
                                                    End

System_XML_NodeQueue                                queue,type
Node                                                    &System_XML_Node
Name                                                    cstring(256)
                                                    end

    ! System_XML_Node_Type_Document

