!****************************************************************************
!  DESCRIPTION...: Core library
!
!  Code contributed by David Harms (www.clarionmag.com) 2013
!  This code is provided "as is" with no warranty express or implied
!****************************************************************************


                                            Member
                                            Map
                                            End



    Include('System_ErrorLog.inc'),Once
    !include('System_Logger.inc'),once

!log                                         System_Logger

System_ErrorLog.AddError                    procedure(string err)
    code
    self.AddError(0,err)
	
System_ErrorLog.AddError                    procedure(long errcode, string err)
    CODE
    self.errorsq.errorcode = ERRCODE
    self.errorsq.error = ERR
    add(self.errorsq)
    
System_ErrorLog.AddErrors                   procedure(*System_ErrorLog errors)
x                                               long
    CODE
    loop x = 1 to records(errors.ErrorsQ)
        get(errors.ErrorsQ,x)
        self.AddError(errors.ErrorsQ.ErrorCode,errors.ErrorsQ.Error)
    END
    
    
    
    
System_ErrorLog.Construct                   PROCEDURE
    CODE
    self.errorsq &= new System_ErrorLog_ErrorsQueue
    
System_ErrorLog.Destruct                    procedure 
    code
    self.Reset()
    dispose(self.errorsq)
    
    
System_ErrorLog.Count                       procedure !,LONG
    code
    return records(self.errorsq)

System_ErrorLog.GetLastErrorCode            procedure !,LONG
    CODE
    if ~records(self.errorsq)
        return 0
    end
    get(self.errorsq,records(self.errorsq))
    return self.errorsq.errorcode
    
System_ErrorLog.GetLastError                procedure !,string
    CODE
    if ~records(self.errorsq)
        return ''
    end
    get(self.errorsq,records(self.errorsq))
    return self.errorsq.error
    
System_ErrorLog.Reset                       procedure
    code
    free(self.errorsq)
    return

    
