!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_Attr.inc'),Once
    include('System_Logger.inc'),once

log                                     System_Logger

System_XML_Attr.Construct                     Procedure()
    code

System_XML_Attr.Destruct                      Procedure()
    code
    self.DisposeValue()
    
System_XML_Attr.CloneFrom                   procedure(*System_XML_Attr sourceAttr)
    code
    self.name = sourceAttr.Name
    self.SetValue(sourceAttr.GetValue())
    
System_XML_Attr.DisposeValue                procedure!,protected
    code
    if not self.Value &= null then dispose(self.Value).
    
System_XML_Attr.GetValue                    procedure!,string
    code
    if not self.Value &= null then return self.Value.
    return ''

System_XML_Attr.Init                        procedure(string name, string value)
    code
    self.Name = name
    self.Setvalue(value)
    
System_XML_Attr.SetValue                    procedure(string value)
    code
    self.DisposeValue()
    self.Value &= new CString(len(clip(value))+1)
    log.write('System_XML_Attr.SetValue: ' & value)
    self.Value = value
    





