!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_CString.inc'),Once
    !include('System_Logger.inc'),once

!dbg                                     System_Logger

System_XML_CString.construct                procedure

    code
    self.CStringText &= new cstring(1)

System_XML_CString.destruct                 procedure

    code
    dispose(self.CStringText)

System_XML_CString.Append                   procedure(string s)
    code
    self.Set(self.CStringText & s)

System_XML_CString.GetCString               procedure!,*CString
    code
    return self.CStringText

System_XML_CString.GetCString               procedure(string s)!,*CString
    code
    self.Set(s)
    return self.CStringText
    
System_XML_CString.GetString                procedure!,string
    code
    return self.CStringText

System_XML_CString.Set                      PROCEDURE(string s)
    code
    dispose(self.CStringText)
    self.CStringText &= new cstring(len(s) + 1)
    self.CStringText = s


