!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_CharacterData.inc'),Once
    !include('System_Logger.inc'),once

!dbg                                     System_Logger

System_XML_CharacterData.Construct                     Procedure()
    code

System_XML_CharacterData.Destruct                      Procedure()
    code
    self.DisposeText()
    
System_XML_CharacterData.DisposeText         procedure!,protected
    code
    if not self.Text &= null then dispose(self.Text).
    
System_XML_CharacterData.GetText            procedure!,string
    code
    if self.Text &= null then return ''.
    return self.Text

System_XML_CharacterData.SetText            procedure(string text)
    code
    self.DisposeText()
    self.Text &= new Cstring(len(text)+1)
    self.Text = text
    
        
    



