!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the asssistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_XPathQuery.inc'),Once

    include('System_Logger.inc'),once
info                                     System_Logger

System_XML_XPathQuery.Construct                     Procedure()
    code
    self.NodeDepthQ &= new System_XML_XPathQuery_NodeDepthQ
    self.NodePathQ &= new System_XML_XPathQuery_NodePathQ


System_XML_XPathQuery.Destruct                   Procedure()
x                                               long
    code
    free(self.NodeDepthQ)
    dispose(self.NodeDepthQ)
    loop x = 1 to records(self.NodePathQ)
        self.NodePathQ.Node &= NULL
        put(self.NodePathQ)
    end
    free(self.NodePathQ)
    dispose(self.NodePathQ)

System_XML_XPathQuery.System_XML_XPath.SelectNodes       procedure(string path)!,*System_XML_NodeList
NodeList                                                &System_XML_NodeList
x                                                       long
    code
    !info.write('looking for nodes with path ' & path)
    NodeList &= new System_XML_NodeList
    loop x = 1 to records(self.NodePathQ)
        get(self.NodePathQ,x)
        !info.write(x & ' = ' & self.nodepathq.NodePath)
        if self.NodePathQ.NodePath = path
            !info.write('Matching node found')
            NodeList.AddNode(self.NodePathQ.Node)
        end
    end
    return NodeList
    
System_XML_XPathQuery.System_XML_XPath.OnNewNode procedure(long level, System_XML_Node node)
x                                                       long    
    code
    !info.write('System_XML_XPathQuery.System_XML_XPath.TakeNewNode(' & level & ',' & node.NodeName & ')')
    loop while records(self.NodeDepthQ) > level - 1
        get(self.NodeDepthQ,records(self.NodeDepthQ))
        delete(self.NodeDepthQ)
    end
    self.NodeDepthQ.NodeName = node.NodeName
    add(self.NodeDepthQ)
    clear(self.NodePathQ)
    loop x = 1 to records(self.NodeDepthQ)
        get(self.NodeDepthQ,x)
        self.NodePathQ.NodePath = self.NodePathQ.NodePath & '/' & self.NodeDepthQ.NodeName
    end
    self.NodePathQ.Node &= node
    self.NodePathQ.NodeLEvel = level
    !info.write('Added node with path ' & self.NodePathQ.NodePath)
    add(self.NodePathQ,self.NodePathQ.NodePath)
    node.NodePath = self.NodePathQ.NodePath
    
    



